/**
 *
 * Copyright 2004 Hiram Chirino
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

package org.activeio;


/**
 * A Channel provides a standard procedure for regulating data transmission between 
 * applications.
 * 
 * The activeio API encourages that layered wire protocols be created by wiring
 * together a chain of Channel objects.   
 * 
 * @version $Revision$
 */
public interface Channel extends Disposable, Service {
    
    /**
     * Since a Channel may be composed from a chain of other Channel obejcts,
     * this method allows you to query the chain for the specified {@param target} interface.
     * 
     * The first Channel in the chain the implments the requested interface will be return
     * an implementing object.  If no Channel in the chain implements the requested class,
     * then null is returned.
     */
    Object narrow(Class target);
}
